#include "dice.h"
#include <string>
#include <iostream>
#include <libcoyotl/command_line.h>
using std::string;
using std::cout;
using std::endl;
using libcoyotl::command_line;
using namespace libgames;

const int roll_count = 8;

void roll_n_times(string label, Rollable & something)
{
	cout << label << ":" << endl;
	for (int i = 0; i < roll_count; i++) {
		cout << something.roll() << endl;
	}
	cout << endl;
}

int main(int argc, char * argv[])
{
	//command_line arguments(argc, argv);
	
	Fixed_Roll f(7); 
	Die d1;
	Reroll_Once_If_Top_Die d2;
	Reroll_Forever_If_Top_Die d3;
	Algebric_Roll d4(d1, false);
	Dice dd;
	dd << f << d1 << d2 << d3 << d4;

	roll_n_times("7", f);
	roll_n_times("d6", d1);
	roll_n_times("d6 reroll once if top", d2);
	roll_n_times("d6 reroll forever if top", d3);
	roll_n_times("-d6", d4);
	roll_n_times("7 + 1d6 + 1d6(reroll once if top) + 1d6(reroll forever if top) - 1d6", dd);
	
	return 0;
}
